#
# utils_concurrent.py
#

from concurrent.futures import ProcessPoolExecutor

## CONFIG
ENABLE_CONCURRENCY = True

class Pool():
	'''Static wrapper around ProcessPoolExecutor'''
	_pool_executor = None

	@staticmethod
	def isEnabled():
		return ENABLE_CONCURRENCY

	@staticmethod
	def pool():
		if not Pool._pool_executor:
			Pool._pool_executor = ProcessPoolExecutor()
		return Pool._pool_executor

	@staticmethod
	def submit(function, *args, **kwargs):
		return Pool.pool().submit(function, *args, **kwargs)
	